package com.fuzamei.web;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URLEncoder;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.fuzamei.service.AccountMaintenanceService;
import com.fuzamei.service.AttachmentService;
import com.fuzamei.service.UserAuthoricationService;
import com.fuzamei.utils.HashXiZhiUtil;
import com.fuzamei.utils.JSONUtil;
import com.fuzamei.utils.PageDTO;

@Controller
@RequestMapping(value = "/AccountMaintenance")
public class AccountMaintenanceAction {
	@Autowired
	private AccountMaintenanceService  accountMaintenanceService;//注入service
	@Autowired
	private AttachmentService attachmentService;//生成附件id随机数service
	/**  
    *  账户开立 添加客户名称和银行账号  上传3份资料  分别插入  附件表  操作记录表，账户开立表
    *  需要完成【申请输】【账户承诺书】【其他凭证】3个文件的上传，插入账务开立表1条数据，插入附件表3条数据，还有插入操作历史1条数据)
    * @param  
    * @param   
    * @throws Exception  
    */
   @RequestMapping(value="/uploadOrInsertAccountMaintenance",method=RequestMethod.POST)  
   @ResponseBody  
   public Map<String,Object> uploadOrInsertBankAccount(@RequestParam("basic_data_id") MultipartFile file,
		@RequestParam("letter_of_commitment_id") MultipartFile file2 ,
   		@RequestParam("application_id") MultipartFile file3, HttpServletRequest request,
   	    @RequestParam("customer_name") String customer_name,
   	    @RequestParam("bank_account") String bank_account) throws IOException{
	   try {
		   String path = "D:\\tomcate\\apache-tomcat-8.5.24\\webapps"+request.getServletContext().getContextPath()+"\\testCeshi";  
		   //String path = request.getServletContext().getRealPath("");	   
		   File dir = new File(path);          
             if(!dir.exists()){  
                 dir.mkdirs();   
             }  
             Map<String, Object> map = new LinkedHashMap<String, Object>();
             map.put("customer_name", customer_name);  
             map.put("bank_account", bank_account);//可以不要  不输入参数   直接在service里put进去   后台插入要求格式以622707开头
             
           //一次性返回3个不同的id号，且不会和数据库中的重复
 			List<Integer> attachmentIds = attachmentService.generateMultiAttachmentIds(3);
 			Integer basicAttachment_id=attachmentIds.get(0);										//其他凭证的id号=====================================>>生成id号的机制要改TODO
 			Integer letterAttachment_id=attachmentIds.get(1);							            //账户承诺、书id号=====================================>>生成id号的机制要改TODO
 			Integer applicationAttachment_id=attachmentIds.get(2);									//开户申请书id号=====================================>>生成id号的机制要改TODO
             
		     //同时上传三个文件 应该产生几个哈希值？？？？？？
             //其他凭证 
             String fileName = file.getOriginalFilename();  
             String pathFile=path+"/"+fileName;
             File newfile = new File(pathFile); 
             file.transferTo(newfile);
             map.put("basicAttachment_id", basicAttachment_id);//附件id暂时写死
     		 map.put("basicAttachment_name", fileName);
     	     map.put("basicUrl","\\testCeshi"+fileName);
     	     
     	     //账户承诺书
    	     String fileName2 = file2.getOriginalFilename();  
             String pathFile2=path+"/"+fileName2;
             File newfile2 = new File(pathFile2); 
             file2.transferTo(newfile2);
             map.put("letterAttachment_id", letterAttachment_id);//附件id暂时写死
    		 map.put("letterAttachment_name", fileName2);
    	     map.put("letterUrl","\\testCeshi"+fileName2);
    	     //开户申请书
        	 String fileName3 = file3.getOriginalFilename();  
             String pathFile3=path+"/"+fileName3;
             File newfile3 = new File(pathFile3); 
             file3.transferTo(newfile3);
             map.put("applicationAttachment_id", applicationAttachment_id);//附件id暂时写死
     	     map.put("applicationAttachment_name", fileName3);
     	     map.put("applicationUrl","\\testCeshi"+fileName3);
     	     
     	    accountMaintenanceService.insertIntoAccountINfo(map);//将经办支行提交的所有数据信息通过map传入service层先进行校验
     	   return JSONUtil.getJsonMap(200, true, "上传成功",null); //返回给前端一个map进行前段提示
	} catch (Exception e) {
		   return JSONUtil.getJsonMap(500, false, "上传出错"+e.getMessage(),null); //返回给前端一个map进行前段提示
	}
	
   }
   
   /**
    * 查询账户维护信息 列表
    * @param data
    * @return
    */
    @PostMapping(value = "/selectAccountMaintenanceInfo")//@PostMapping此注解 提交方式为post
	@ResponseBody
	public Map<String, Object> selectAccountMaintenanceInfo(@RequestBody String data) {
		//System.out.println("查询账户维护开立信息列表");
		Map<String, Object> mapResult = new LinkedHashMap<String, Object>();
		Map<String, Object> map = JSONUtil.jsonToMap(data);
		PageDTO pageDto=accountMaintenanceService.selectAccountMaintenanceInfo(map);
		mapResult = JSONUtil.getJsonMap(200, true, "操作查询成功", pageDto);

		return mapResult;
	}
	
    /**
	 * 账户开立   点击查看详情  显示下载文件的提示框
	 * @param data
	 * @return
	 */
	@RequestMapping(value = "/selectAccountMaintenanceNoPage",method = RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> selectAccountMaintenanceNoPage(@RequestBody String data){
		
		//System.out.println("账户开立查看 供应下载....");
		Map<String, Object> map = JSONUtil.jsonToMap(data);	// 将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
		Map<String, Object> mapFromService = accountMaintenanceService.selectAccountMaintenanceNoPage(map); //这里不要分页，只要service传过来一个map对象即可
		
		return JSONUtil.getJsonMap(200, true, "操作成功", mapFromService); //将从service返回回来的map对象通过map对象直接返回给前端
	}
	
	/**  
	 * 账户开立下载 doc文档
	 * @param request  
	 * @param response  
	 * @throws Exception  
	 */  
	@RequestMapping(value="/downloadAccountFile")  
	@ResponseBody 
	public Map<String,Object> downloadAccountFile(HttpServletRequest request,HttpServletResponse response,@RequestParam("url") String url) throws Exception{  
	    try {
	    	  //模拟文件，456.doc为需要下载的文件  
	        String fileName = request.getSession().getServletContext().getRealPath("")+url;  
	        //获取输入流  
	        InputStream bis = new BufferedInputStream(new FileInputStream(new File(fileName))); 
	        //截取文件名字
	        String filename = url.substring(url.lastIndexOf("/")+1);
	        //转码，免得文件名中文乱码  
	        filename = URLEncoder.encode(filename,"UTF-8");  
	        //设置文件下载头  
	        response.addHeader("Content-Disposition", "attachment;filename=" + filename);    
	        //1.设置文件ContentType类型，这样设置，会自动判断下载文件类型    
	        response.setContentType("multipart/form-data");   
	        BufferedOutputStream out = new BufferedOutputStream(response.getOutputStream());  
	        int len = 0;  
	        while((len = bis.read()) != -1){  
	            out.write(len);  
	            out.flush();  
	        }  
	        out.close(); 
	        bis.close();
	        //返给前端map进行前端提示
	    	return JSONUtil.getJsonMap(200, true, "下载成功",null); 
			
		} catch (Exception e) {
			return JSONUtil.getJsonMap(500, false, "下载失败:"+e.getMessage(),null); 
		}
	} 
	
	
	
	
	
	
	
	
	
	
}
